<template>
  <q-dialog
    v-model="popupFullSize"
    persistent
    :maximized="maximizedToggle"
    transition-show="slide-up"
    transition-hide="slide-down"
    ref="dialogRef"
  >
    <q-card class="">
      <q-bar>
        <q-space />
        <q-btn
          dense
          flat
          icon="minimize"
          @click="maximizedToggle = false"
          :disable="!maximizedToggle"
        >
          <q-tooltip v-if="maximizedToggle" class="bg-white text-primary"
            >Minimize</q-tooltip
          >
        </q-btn>
        <q-btn
          dense
          flat
          icon="crop_square"
          @click="maximizedToggle = true"
          :disable="maximizedToggle"
        >
          <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary"
            >Maximize</q-tooltip
          >
        </q-btn>
        <q-btn dense flat icon="close" v-close-popup>
          <q-tooltip class="bg-white text-primary">Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <div class="text-h6">{{ windowObj.title }}</div>
      </q-card-section>

      <q-card-section class="q-pt-none" v-if="windowObj.type === 'addField'">
        <form action="">
          <q-input filled v-model="addFieldNom" label="nom" type="text" />
          <br />
          <q-color
            v-model="addFieldColor"
            no-header-tabs
            class="my-picker"
            default-view="palette"
          />
          <br />
          <q-input
            filled
            v-model="addFieldComment"
            label="commentaires"
            type="text"
          />
          <q-btn
            @click.prevent="addFieldForm"
            label="ajouter"
            type="submit"
            color="primary"
            icon="add"
          />
        </form>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script>
import { defineComponent, ref } from 'vue';
import { useQuasar, useDialogPluginComponent } from 'quasar';
import { useAuthStore } from 'src/stores/authStore.js';

export default defineComponent({

  props: {
    windowObj: {
      type: Object,
      required: true,
    },
  },

  emits: [
    ...useDialogPluginComponent.emits,
  ],

  setup(props) {
    const quasar = useQuasar();
    const authStore = useAuthStore();
    const addFieldNom = ref('');
    const addFieldColor = ref('');
    const addFieldComment = ref('');
    const {
      dialogRef,
      onDialogHide,
    } = useDialogPluginComponent();
    const maximizedToggle = ref(true);
    const popupFullSize = ref('');

    const addFieldForm = () => {
      console.log('addFieldForm submit');
      console.log(addFieldNom.value);
      console.log(addFieldColor.value);
      console.log(addFieldComment.value);
      if (
        addFieldNom.value !== ''
        && addFieldColor.value !== ''
        && addFieldNom.value !== null
        && addFieldColor.value !== null
      ) {
        const requestOptionsConn = {
          method: 'POST',
          headers: {
            'Content-Type': 'application/json',
            Authorization: `Bearer ${authStore.jwt}`,
          },
          body: JSON.stringify({
            fieldName: addFieldNom.value,
            fieldColor: addFieldColor.value,
            fieldComment: addFieldComment.value,
          }),
        };

        fetch(
          `${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs`,
          requestOptionsConn,
        )
          .then((response) => {
            if (response.status !== 200) {
              quasar.dialog({
                title: 'Alert',
                message: 'un problème est survenu ...',
              });
              throw response.status;
            }
            try {
              addFieldNom.value = '';
              addFieldColor.value = '';
              addFieldComment.value = '';
              popupFullSize.value = false; // close popup
              quasar.notify({
                message: 'le champ a été ajouter',
                color: 'positive',
                badgeTextColor: 'white',
                progress: true,
              });
            } catch (e) {
              console.log('error - no valid response');
              console.log(e);
            }
            return response.json();
          })
          .then((json) => {
            // push new info dans Pinia
            authStore.userObject.champs.push(json);
            // push new info dans LocalStorage
            // DEBUG?????
            // authStore.updateUserObject(authStore.userObject);
          });
      } else {
        quasar.notify({
          message: 'vous devez renseigner le nom et la couleur',
          color: 'negative',
          badgeTextColor: 'white',
          progress: true,
        });
      }
    };

    return {
      dialogRef,
      onDialogHide,
      maximizedToggle,
      popupFullSize,
      addFieldNom,
      addFieldColor,
      addFieldComment,
      addFieldForm,
      ...props,
    };
  },
});
</script>
